/*
 * mwAnimation v1.0.0
 *
 * URL: http://blog.wantedlink.de
 * (c) 2014 Mario Wolf
 */

// http://paulirish.com/2011/requestanimationframe-for-smart-animating
window.requestAnimFrame = (function(){
	return  window.requestAnimationFrame       || 
          	window.webkitRequestAnimationFrame || 
          	window.mozRequestAnimationFrame    || 
          	window.oRequestAnimationFrame      || 
          	window.msRequestAnimationFrame     || 
          	function( callback ){
           		window.setTimeout(callback, 1000/60);
          	};
})();


// namespace for animation

function mwAnimation() {
	var t = this;
	t.field = null;
    t.canvas = null;
    t.ctx = null;		//canvas context 
    t.run = true;

	t.box01 = null;
	t.box02 = null;
	t.box03 = null;
	t.box04 = null;
	t.box05 = null;

	init();

	function init() {

		t.canvas = document.getElementById('main');
        t.canvas.width = 270;
        t.canvas.height = 270;
        t.ctx = t.canvas.getContext('2d');

        t.box01 = new Field(110, 50, 50, 50);
        t.box01.autoAlpha = true;
        t.box01.setFillStyle();

        t.box02 = new Field(170, 110, 50, 50);
		t.box02.autoAlpha = true;
		t.box02.setFillStyle();

        t.box03 = new Field(50, 170, 50, 50);
		t.box03.autoAlpha = true;
		t.box03.setFillStyle();

        t.box04 = new Field(110, 170, 50, 50);
		t.box04.autoAlpha = true;
		t.box04.setFillStyle();
		
        t.box05 = new Field(170, 170, 50, 50);  
        t.box05.autoAlpha = true;
        t.box05.setFillStyle();

		animate();	//call loop func
	}

	function animate() {
		draw();
		if(t.run) {	// endless loop ...
    		requestAnimFrame( animate );	
		}
	}

	function draw(){

		t.ctx.beginPath();

		t.box01.render(t.ctx);

		if(t.box01.alpha==1){
			t.box02.render(t.ctx);
		}
		if(t.box01.alpha==1 && t.box02.alpha==1){
			t.box03.render(t.ctx);
		}
		if(t.box01.alpha==1 && t.box02.alpha==1 && t.box03.alpha==1){
			t.box04.render(t.ctx);
		}
		if(t.box01.alpha==1 && t.box02.alpha==1 && t.box03.alpha==1 && t.box04.alpha==1){
			t.box05.render(t.ctx);
		}
		
		if(t.box05.alpha==1) {
			t.run = false;
		}

		t.ctx.stroke();
	}

}

/*
	Field
*/
function Field(l_x, l_y, l_width, l_height){ 
	var t = this;
 		
 	t.x = l_x;
 	t.y = l_y;
 	t.width = l_width; 
 	t.height = l_height; 
 	t.fillStyle = '#000000';

 	t.alpha = 0;
 	t.autoAlpha = false;

 	t.render = function(ctx){ 
 		ctx.clearRect(t.x, t.y, t.width, t.height);
 		ctx.fillStyle = t.fillStyle;
 		if(t.autoAlpha){
 			ctx.globalAlpha = t.calcAlpha();
 		}
 		else {
 			ctx.globalAlpha = 1;
 		}
 		ctx.fillRect(t.x, t.y, t.width, t.height); //fillRect
 	}

 	t.calcAlpha = function() {

		if(t.alpha<1) {
			t.alpha += 0.01;
		}
		else{
			t.alpha = 1;
		}

		return t.alpha;
 	}

 	t.setFillStyle = function() {
 		t.fillStyle = '#' + randomColor() + randomColor() + randomColor();
 	}
 	
}

/*  
	start
*/
function randomColor(){

	var hex = Math.floor((Math.random() * 255)).toString(16);

	if(hex.length < 2) {
        hex = "0" + hex;
    }

	return hex.toUpperCase();
}

/*  
	start
*/
window.addEventListener("load", running, false);

function running() {
	new mwAnimation();
}